import es
import random
import gamethread

info = es.AddonInfo() 
info.name     = "UNO" 
info.version  = "1.0.0" 
info.url      = "http://addons.eventscripts.com/addons/view/uno" 
info.basename = "UNO" 
info.author   = "DHack" 
es.ServerVar('UNO_Ver', info.version, 'UNO Version').makepublic()

gameon = 'False'
unoplayers = {}
turns = []
topcard = 'none'
def load():
    es.regsaycmd('!join', 'uno/join', 'Join the uno game')
    es.regsaycmd('!joinuno', 'uno/join', 'Join the uno game')
    es.regsaycmd('!hand', 'uno/hand', 'Tells you your uno hand')
    es.regsaycmd('!showhand', 'uno/hand', 'Tells you your uno hand')
    es.regsaycmd('!play', 'uno/play', 'Play A Card, or draw')
    es.regsaycmd('!turn', 'uno/turn', 'Tells the order of turns')
    es.regsaycmd('!tc', 'uno/tc', 'Tells the order of turns')
    es.regsaycmd('!topcard', 'uno/tc', 'Tells the order of turns')
    es.regsaycmd('!uno', 'uno/commands', 'Tells uno commands')
    es.regsaycmd('!leave', 'uno/leave', 'Lets you leave the uno game')
    es.regsaycmd('!leavegame', 'uno/leave', 'Lets you leave the uno game')
    es.regsaycmd('!players', 'uno/players', 'Lets you leave the uno game')
def commands():
    userid = es.getcmduserid()
def player_disconnect(ev):
    if int(ev['userid']) in turns:
       leave(ev['userid']) 
def players():
    userid = es.getcmduserid()
    tell(userid, turns)
def leave(userid = 'none'):
    if userid == 'none':
        userid = es.getcmduserid()
    if turns[0] and userid == turns[0]:
        lastplayer = turns[0]
        del turns[0]
        tell(userid, 'You have left the UNO game!')
        if turns:
            for users in turns:
                tell(users, '#lightgreen%s #defaultHas left the game.' % es.getplayername(lastplayer))
        if len(turns) > 1:
            next()
        else:
            gameend(turns[0])
        return
    del turns[turns.index(int(userid))]
    if len(turns) > 1:
        next()
def tc():
    tell(es.getcmduserid(), 'Top card is #lightgreen%s' % topcard)
def turn():
    if turns:
        userid = es.getcmduserid()
        tell(userid, "It's " + str(es.getplayername(turns[0])) + " Turn")
def join():
    userid = es.getcmduserid()
    if not userid in turns and len(turns) < 7:
        if not userid in unoplayers:
            unoplayers[userid] = []
            x = 0
            while x < 7:
                x += 1
                unoplayers[userid].append(getcard())
        turns.append(userid)
        tell(userid, 'You are now playing uno')
        if gameon == 'True':
            tell(userid, 'You are now playing UNO. Wait your turn.')
        elif len(unoplayers) == 1:
            tell(userid, 'You must wait till another person joins you')
        elif gameon == 'False' and len(turns) == 2:
            startgame()
        elif gameon == 'intermission':
            tell(userid, 'You are now in the game. Please wait for the intermission to be over.')
    else:
        tell(userid, 'Sorry game is full')
def getcard():
    color = random.randint(1, 4)
    number = str(random.randint(1, 7))
    if color == 1:
        return 'R'+number
    elif color == 2:
        return 'G'+number
    elif color == 3:
        return 'Y'+number
    elif color == 4:
        return 'B'+number
def play():
    global topcard
    userid = es.getcmduserid()
    command = str(es.getargv(1)).lower()
    if turns and userid == turns[0]:
        if command.upper() in unoplayers[userid]:
            for letter in topcard:
                if letter.lower() in command:
                    for player in turns:
                        if not userid == player:
                            tell(player, 'Player #lightgreen%s #defaulthas played a #lightgreen%s'%(es.getplayername(userid),command.upper()))
                        else:
                            tell(player, 'You have played A #lightgreen%s' % command.upper())
                    del unoplayers[userid][unoplayers[userid].index(command.upper())]
                    if check(userid) == 0:
                        gameend(userid)
                        return
                    topcard = command.upper()
                    lastplayer = turns[0]
                    del turns[0]
                    turns.append(lastplayer)
                    next()
                    return
            tell(userid, 'You cant play a #lightgreen%s' % es.getargv(1))
        if command == 'draw':
            newcard = getcard()
            unoplayers[userid].append(newcard)
            tell(userid, 'You drew a #lightgreen%s' % newcard)
        else:
            tell(userid, 'You do not have a #lightgreen%s' % es.getargv(1))
            
    else:
        tell(userid, 'It is not your turn')
def next():
    tell(turns[0], 'Its now your turn topcard is #lightgreen%s' % topcard)
    hand(turns[0])
def startgame():
    global topcard, gameon
    gameon = 'True'
    for userid in turns:
        tell(userid, 'Game Has Now Started')
    topcard = getcard()
    next()
def check(userid):
    if userid in turns:
        return len(unoplayers[userid])
def tell(userid ,text):
    es.tell(userid, "#multi", "#green[UNO Dealer] #lightgreen%s #default%s."%(es.getplayername(userid),text))
def hand(userid = 'none'):
    if userid == 'none':
        userid = es.getcmduserid()
    tell(userid, 'Your hand is: %s'%unoplayers[userid])
def gameend(winner):
    global unoplayers
    global turns
    global topcard
    global gameon
    unoplayers = {}
    turns = []
    topcard = 'none'
    gameon = 'intermission'
    if winner != 'none':
        es.msg("#multi", "#green[UNO Dealer] #defaultA game of UNO has just been won by #lightgreen%s." % es.getplayername(winner))
    else:
        es.msg("#multi", "#green[UNO Dealer] #defaultA game of UNO has just been won by #lightgreenNo onE.")
    es.msg("#multi", "#green[UNO Dealer] #defaultA new game will now start after a 60 sec intermission, type !join to play.")
    gamethread.delayed(60, endintermission) 
def endintermission():
    global gameon
    if len(unoplayers) > 1:
        gameon = 'True'
        startgame()
    else:
        gameon = 'False'